local _, tab = ...
local templates = {}
tab.templ = templates
templates["Generic"] = {
	noenchant = {
		noclass=0, -- unless specified, unenchanted slots are BAD
		Trinket0=2, -- trinket has no enchants
		Trinket1=2,
		Finger0=2, -- ring, same as above
		Finger1=2,
		Ranged=2, -- nn to enchant ranged weap
		Neck=2, -- no enchant for neck
		Shoulder=1, -- possibly not enough rep
		Head=1, -- same as shoulder
		Tabard=2, -- tabard cant be enchanted
		Shirt=2, -- same
		Waist=2, -- you'll find enchanting a belt fairly hard (belt buckle doesn't count as one itemString-wise)
	},
	stats = {
		-- gems are handled seperately, not as stats
		EMPTY_SOCKET_COGWHEEL=2,
		EMPTY_SOCKET_PRISMATIC=2,
		EMPTY_SOCKET_RED=2,
		EMPTY_SOCKET_YELLOW=2,
		EMPTY_SOCKET_BLUE=2,
		EMPTY_SOCKET_META=2,
		ITEM_MOD_STAMINA_SHORT=2, -- finding items without stamina is fairly hard
		ITEM_MOD_DAMAGE_PER_SECOND_SHORT=2, -- dps is fetched as a stat
		RESISTANCE0_NAME=2, -- armor
	},
}
templates["Tank"] = {
	gemming = {
		noclass=0, -- non-listed are undesirable (X)
		---------
		-- red --
		---------
		[52206]=1, -- bold (strength) is questionable
		[52212]=1, -- delicate (agility) is questionable
		[52207]=0, -- brillant (intellect) is undesirable
		[52216]=2, -- flashing (parry rating) is desirable
		[52230]=2, -- precise (expertise rating) is desirable
		[52255]=1, -- str JC gem is questionable
		[52257]=0, -- int JC gem is undesirable
		[52258]=1, -- agi JC gem is questionable
		[52259]=2, -- parry JC gem is fine
		[52260]=2, -- expertise JC gem is fine
		[52176]="addon.opt.allowPerfectUncommon and 1 or 0", -- str perfect questionable if even allowed
		[52173]=0, -- int perfect
		[52175]="addon.opt.allowPerfectUncommon and 1 or 0", -- agi perfect
		[52174]="addon.opt.allowPerfectUncommon and 2 or 0", -- parry perfect
		[52172]="addon.opt.allowPerfectUncommon and 2 or 0", -- expertise perfect
		[52081]="addon.opt.allowImperfectUncommon and 1 or 0", -- str uncommon
		[52084]=0, -- int uncommon
		[52082]="addon.opt.allowImperfectUncommon and 1 or 0", -- agi uncommon
		[52083]="addon.opt.allowImperfectUncommon and 2 or 0", -- parry uncommon
		[52085]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp uncommon
		----------
		-- blue --
		----------
		[52261]=2, -- stam JC gem
		[52264]=1, -- hit jc gem
		[52262]=0, -- spir jc gem
		[52263]=0, -- spen jc gem
		[52235]=1, -- hit rare
		[52242]=2, -- stam rare
		[52244]=0, -- spir rare
		[52246]=0, -- spen rare
		[52168]="addon.opt.allowPerfectUncommon and 1 or 0", -- hit perfect
		[52171]="addon.opt.allowPerfectUncommon and 2 or 0", -- stam perfect
		[52170]=0, -- spir perfect
		[52169]=0, -- spen perfect
		[52089]="addon.opt.allowImperfectUncommon and 1 or 0", -- hit uncommon
		[52086]="addon.opt.allowImperfectUncommon and 2 or 0", -- stam uncommon
		[52087]=0, -- spir uncommon
		[52088]=0, -- spen uncommon
		------------
		-- yellow --
		------------
		[52269]=2, -- mastery JC gem
		[52267]=0, -- resil JC gem
		[52268]=1, -- haste JC gem
		[52266]=1, -- crit JC gem
		[52265]=2, -- dodge JC gem
		[52219]=2, -- mastery rare
		[52226]=0, -- resil rare
		[52232]=1, -- haste rare
		[52241]=1, -- crit rare
		[52247]=2, -- dodge rare
		[52163]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery perfect
		[52165]=0, -- resil perfect
		[52164]="addon.opt.allowPerfectUncommon and 1 or 0", -- haste perfect
		[52166]="addon.opt.allowPerfectUncommon and 1 or 0", -- crit perfect
		[52167]="addon.opt.allowPerfectUncommon and 2 or 0", -- dodge perfect
		[52094]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery uncommon
		[52092]=0, -- resil uncommon
		[52093]="addon.opt.allowImperfectUncommon and 1 or 0", -- haste uncommon
		[52091]="addon.opt.allowImperfectUncommon and 1 or 0", -- crit uncommon
		[52090]="addon.opt.allowImperfectUncommon and 2 or 0", -- dodge uncommon
		------------
		-- purple --
		------------
		[52203]=1, -- hit/exp rare
		[52210]=2, -- parry/stam rare
		[52213]=1, -- str/hit rare
		[52220]=1, -- agil/hit rare
		[52221]=2, -- exp/stam rare
		[52236]=0, -- int/spi rare
		[52234]=1, -- parry/hit rare
		[52238]=1, -- agi/stam rare
		[52243]=2, -- str/stam rare
		[52248]=0, -- int/stam rare
		[52217]=0, -- int/hit rare
		[52152]="addon.opt.allowPerfectUncommon and 1 or 0", -- hit/exp perfect
		[52160]="addon.opt.allowPerfectUncommon and 2 or 0", -- parry/stam perfect
		[52156]="addon.opt.allowPerfectUncommon and 1 or 0", -- str/hit perfect
		[52155]="addon.opt.allowPerfectUncommon and 1 or 0", -- agi/hit perfect
		[52158]="addon.opt.allowPerfectUncommon and 2 or 0", -- exp/stam perfect
		[52157]=0, -- int/spirit perfect
		[52154]="addon.opt.allowPerfectUncommon and 1 or 0", -- parry/hit perfect
		[52161]="addon.opt.allowPerfectUncommon and 1 or 0", -- agi/stam perfect
		[52162]="addon.opt.allowPerfectUncommon and 2 or 0", -- str/stam perfect
		[52159]=0, -- int/stam perfect
		[52153]=0, -- int/hit perfect
		[52105]="addon.opt.allowImperfectUncommon and 1 or 0", -- exp/hit uncommon
		[52097]="addon.opt.allowImperfectUncommon and 2 or 0", -- parry/stam uncommon
		[52101]="addon.opt.allowImperfectUncommon and 1 or 0", -- str/hit uncommon
		[52102]="addon.opt.allowImperfectUncommon and 1 or 0", -- agi/hit uncommon
		[52099]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp/stam uncommon
		[52100]=0, -- int/spi uncommon
		[52103]="addon.opt.allowImperfectUncommon and 1 or 0", -- parry/hit uncommon
		[52096]="addon.opt.allowImperfectUncommon and 1 or 0", -- agi/stam uncommon
		[52095]="addon.opt.allowImperfectUncommon and 2 or 0", -- str/stam uncommon
		[52098]=0, -- int/stam uncommon
		[52104]=0, -- int/hit uncommon
		-----------
		-- green --
		-----------
		[52218]=1, -- haste/stam rare
		[52223]=1, -- crit/stam rare
		[52225]=1, -- haste/hit rare
		[52227]=1, -- dodge/hit rare
		[52228]=1, -- crit/hit rare
		[52231]=2, -- mastery/stam rare
		[52233]=2, -- dodge/stam rare
		[52237]=1, -- mastery/hit rare
		[52245]=1, -- resil/stam rare
		[52250]=0, -- mastery/spirit rare
		[52133]="addon.opt.allowPerfectUncommon and 1 or 0", -- haste/stam perfect
		[52136]="addon.opt.allowPerfectUncommon and 1 or 0", -- crit/stam perfect
		[52132]="addon.opt.allowPerfectUncommon and 1 or 0", -- haste/hit perfect
		[52137]="addon.opt.allowPerfectUncommon and 1 or 0", -- dodge/hit perfect
		[52135]="addon.opt.allowPerfectUncommon and 1 or 0", -- crit/hit perfect
		[52131]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery/stam perfect
		[52138]="addon.opt.allowPerfectUncommon and 2 or 0", -- dodge/stam perfect
		[52129]="addon.opt.allowPerfectUncommon and 1 or 0", -- mastery/hit perfect
		[52134]="addon.opt.allowPerfectUncommon and 1 or 0", -- resil/stam perfect
		[52130]=0, -- mastery/spirit perfect
		[52124]="addon.opt.allowImperfectUncommon and 1 or 0", -- haste/stam uncommon
		[52121]="addon.opt.allowImperfectUncommon and 1 or 0", -- crit/stam uncommon
		[52125]="addon.opt.allowImperfectUncommon and 1 or 0", -- haste/hit uncommon
		[52120]="addon.opt.allowImperfectUncommon and 1 or 0", -- dodge/hit uncommon
		[52122]="addon.opt.allowImperfectUncommon and 1 or 0", -- crit/hit uncommon
		[52126]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery/stam uncommon
		[52119]="addon.opt.allowImperfectUncommon and 2 or 0", -- dodge/stam uncommon
		[52128]="addon.opt.allowImperfectUncommon and 1 or 0", -- mastery/hit uncommon
		[52123]="addon.opt.allowImperfectUncommon and 1 or 0", -- resil/stam uncommon
		[52127]=0, -- mastery/spirit uncommon
		------------
		-- orange --
		------------
		[52204]=1, -- agil/mastery rare
		[52205]=0, -- int/mastery rare
		[52209]=1, -- agil/crit rare
		[52211]=1, -- agil/haste rare
		[52214]=1, -- str/haste rare
		[52215]=2, -- parry/mastery rare
		[52222]=1, -- str/crit rare
		[52224]=2, -- exp/mastery rare
		[68357]=0, -- agil/resil rare
		[52229]=1, -- agil/dodge rare
		[52239]=0, -- int/crit rare
		[52208]=0, -- int/haste rare
		[52249]=2, -- exp/dodge rare
		[68358]=0, -- str/resil rare
		[52240]=1, -- str/mastery rare
		[68356]=0, -- int/resil rare
		[52142]="addon.opt.allowPerfectUncommon and 1 or 0", -- agil/mastery perfect
		[52140]=0, -- int/mastery perfect
		[52148]="addon.opt.allowPerfectUncommon and 1 or 0", -- agil/crit perfect
		[52145]="addon.opt.allowPerfectUncommon and 1 or 0", -- agil/haste perfect
		[52146]="addon.opt.allowPerfectUncommon and 1 or 0", -- str/haste perfect
		[52141]="addon.opt.allowPerfectUncommon and 2 or 0", -- parry/mastery perfect
		[52149]="addon.opt.allowPerfectUncommon and 1 or 0", -- str/crit perfect
		[52139]="addon.opt.allowPerfectUncommon and 2 or 0", -- exp/mastery perfect
		[52151]="addon.opt.allowPerfectUncommon and 1 or 0", -- agil/dodge perfect
		[52147]=0, -- int/crit rare
		[52144]=0, -- int/haste rare
		[52150]="addon.opt.allowPerfectUncommon and 2 or 0", -- exp/dodge perfect
		[52143]="addon.opt.allowPerfectUncommon and 1 or 0", -- str/mastery perfect
		[52115]="addon.opt.allowImperfectUncommon and 1 or 0", -- agil/mastery uncommon
		[52117]=0, -- int/mastery uncommon
		[52109]="addon.opt.allowImperfectUncommon and 1 or 0", -- agil/crit uncommon
		[52112]="addon.opt.allowImperfectUncommon and 1 or 0", -- agil/haste uncommon
		[52111]="addon.opt.allowImperfectUncommon and 1 or 0", -- str/haste uncommon
		[52116]="addon.opt.allowImperfectUncommon and 2 or 0", -- parry/mastery uncommon
		[52108]="addon.opt.allowImperfectUncommon and 1 or 0", -- str/crit uncommon
		[52118]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp/mastery uncommon
		[52106]="addon.opt.allowImperfectUncommon and 1 or 0", -- agil/dodge uncommon
		[52110]=0, -- int/crit uncommon
		[52113]=0, -- int/haste uncommon
		[52107]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp/dodge uncommon
		[52114]="addon.opt.allowImperfectUncommon and 1 or 0", -- str/mastery uncommon
		--------------
		-- cogwheel --
		--------------
		[59491]=2, -- parry
		[59480]=2, -- mastery
		[59489]=2, -- expertise
		[59479]=1, -- haste
		[59493]=2, -- hit
		[59478]=1, -- crit
		[59496]=0, -- spirit
		[59477]=2, -- dodge
	},
	enchanting = {
		noclass=0, -- non-listed are undesirable (X)
		----------
		-- back --
		----------
		[4064]=0, -- 70 spen
		[4072]=0, -- 30 int
		[4087]=1, -- 50 crit
		[4090]=2, -- 250 armor
		[4096]=0, -- 50 int
		[4100]=1, -- 65 crit
		[4116]=0, -- tailoring mana restore (darkglow)
		[4115]=0, -- tailoring spell power (lightweave)
		[4118]=1, -- tailoring attack power (swordguard)
		-----------
		-- chest --
		-----------
		[4063]=1, -- 15 stats
		[4070]=2, -- 55 stam
		[4077]=0, -- 40 resil
		[4088]=0, -- 40 spirit
		[4103]=2, -- 75 stam
		[4102]=1, -- 20 stats
		----------
		-- feet --
		----------
		[4062]=2, -- 30 stam and movespeed
		[4069]=1, -- 50 haste
		[4076]=1, -- 35 agi
		[4092]=2, -- 50 hit
		[4094]=2, -- 50 mastery
		[4105]=1, -- 25 agil and movespeed
		[4104]=2, -- 35 mastery and movespeed
		------------------------
		-- ring self-enchants --
		------------------------
		[4079]=1, -- agi
		[4081]=2, -- stam
		[4080]=0, -- int
		[4078]=2, -- str
		-----------
		-- hands --
		-----------
		[4061]=2, -- 50 mastery
		[4068]=1, -- 50 haste
		[4075]=1, -- 35 str
		[4082]=2, -- 50 exp
		[4107]=2, -- 65 mastery
		[4106]=1, -- 50 str
		[3246]=0, -- 28 sp
		[3253]=2, -- 2% threat 10 parry (armsman)
		----------
		-- head --
		----------
		[4208]=2, -- 60 str 35 mastery
		[4206]=2, -- 90 stam 35 dodge
		[4209]=1, -- 60 agil 35 haste
		[4207]=0, -- 60 int 35 crit
		--------------
		-- off-hand --
		--------------
		[4091]=0, -- 100 int
		------------
		-- weapon --
		------------
		[4067]=1, -- nature damage proc (avalanche)
		[4066]=2, -- heal proc [procs off dots] (mending)
		[4074]=1, -- arcane damage + silence proc only vs elementals (elemental slayer)
		[4083]=1, -- 450 haste proc (hurricane)
		[4084]=0, -- 200 spirit oncast proc (heartsong)
		[4099]=1, -- 1000 ap proc (landslide)
		[4097]=0, -- 500 int oncast proc (power torrent)
		[4098]=2, -- 600 dodge 15% movespeed proc (windwalk)
		[3834]=0, -- 63 sp
		[3830]=0, -- 50 sp
		------------
		-- ranged --
		------------
		[4177]=1, -- 88 ranged haste
		[4176]=1, -- 88 ranged hit
		[4175]=1, -- 800 ap ranged proc
		------------
		-- shield --
		------------
		[4085]=2, -- 40 block rating
		[4073]=2, -- 160 armor
		--------------
		-- shoulder --
		--------------
		[4197]=2, -- stam/dodge honored
		[4205]=1, -- agi/mastery honored
		[4201]=1, -- str/crit honored
		[4199]=0, -- int/haste honored
		[4198]=2, -- stam/dodge exalted
		[4204]=1, -- agi/mastery exalted
		[4202]=1, -- str/crit exalted
		[4200]=0, -- int/haste exalted
		[4193]=1, -- 130 agi 25 mastery (inscription self-enchant)
		[4196]=0, -- 130 int 25 haste (inscription self-enchant)
		[4195]=2, -- 195 stam 25 dodge (inscription self-enchant)
		[4194]=1, -- 130 str 25 crit (inscription self-enchant)
		---------------
		-- 2h weapon --
		---------------
		[4227]=0, -- 130 agi
		-----------
		-- wrist --
		-----------
		[4065]=1, -- 50 haste
		[4071]=1, -- 50 crit
		[4086]=2, -- 50 dodge
		[4089]=2, -- 50 hit
		[4093]=0, -- 50 spirit
		[4095]=2, -- 50 exp
		[4101]=1, -- 65 crit
		[4108]=1, -- 65 haste
		[4190]=1, -- 130 agi
		[4192]=0, -- 130 int
		[4189]=2, -- 195 stam
		[4191]=1, -- 130 str
		[2332]=0, -- 30 sp
		[3850]=2, -- 40 stam
		----------
		-- legs --
		----------
		[4127]=2, -- 145 stam 55 agi
		[4126]=1, -- 190 ap 55 crit
		[4112]=0, -- 95 int 80 stam
		[4113]=0, -- 95 int 80 stam tailoring
		[4110]=0, -- 95 int 55 spir
		[4124]=2, -- 85 stam 45 agi
		[4122]=1, -- 110 ap 45 crit
		[4111]=0, -- 55 int 65 stam
		[4109]=0, -- 55 int 45 spir
		-----------
		-- staff --
		-----------
		[3854]=0, -- 81 sp
		[3855]=0, -- 69 sp
	},
	stats = {
		noclass=0, -- non-listed are undesirable (X)
		inherits="Generic",
		ITEM_MOD_CRIT_RATING_SHORT=1, -- crit rating
		ITEM_MOD_MASTERY_RATING_SHORT=2, -- mastery
		ITEM_MOD_STRENGTH_SHORT=2, -- str
		ITEM_MOD_AGILITY_SHORT=1, -- agility
		ITEM_MOD_HASTE_RATING_SHORT=1, -- haste
		ITEM_MOD_SPELL_POWER_SHORT=0, -- spell power
		ITEM_MOD_SPIRIT_SHORT=0, -- spirit
		ITEM_MOD_INTELLECT_SHORT=0, -- intellect
		ITEM_MOD_SPELL_PENETRATION_SHORT=0, -- spell pen
		ITEM_MOD_RESILIENCE_RATING_SHORT=0, -- resil
		ITEM_MOD_HEALTH_REGEN_SHORT=2, -- hp regen
		ITEM_MOD_ATTACK_POWER_SHORT=0, -- ap
		ITEM_MOD_EXPERTISE_RATING_SHORT=2, -- exp
		ITEM_MOD_HIT_RATING_SHORT=2, -- hit
		ITEM_MOD_PARRY_RATING_SHORT=2, -- parry
		ITEM_MOD_DODGE_RATING_SHORT=2, -- dodge
	},
	noenchant={
		inherits="Generic",
	}
}



templates["Agility Melee"] = {
	gemming = {
		noclass=0, -- non-listed are undesirable (X)
		---------
		-- red --
		---------
		[52206]=1, -- str rare
		[52212]=2, -- agi rare
		[52207]=0, -- int rare
		[52216]=0, -- parry rare
		[52230]=2, -- exp rare
		[52255]=1, -- str JC gem
		[52257]=0, -- int JC gem
		[52258]=2, -- agi JC gem
		[52259]=0, -- parry JC gem
		[52260]=2, -- expertise JC gem
		[52176]="addon.opt.allowPerfectUncommon and 1 or 0", -- str perfect
		[52173]=0, -- int perfect
		[52175]="addon.opt.allowPerfectUncommon and 2 or 0", -- agi perfect
		[52174]=0, -- parry perfect
		[52172]="addon.opt.allowPerfectUncommon and 2 or 0", -- expertise perfect
		[52081]="addon.opt.allowImperfectUncommon and 1 or 0", -- str uncommon
		[52084]=0, -- int uncommon
		[52082]="addon.opt.allowImperfectUncommon and 2 or 0", -- agi uncommon
		[52083]=0, -- parry uncommon
		[52085]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp uncommon
		----------
		-- blue --
		----------
		[52261]=0, -- stam JC gem
		[52264]=2, -- hit jc gem
		[52262]=0, -- spir jc gem
		[52263]=0, -- spen jc gem
		[52235]=2, -- hit rare
		[52242]=0, -- stam rare
		[52244]=0, -- spir rare
		[52246]=0, -- spen rare
		[52168]="addon.opt.allowPerfectUncommon and 2 or 0", -- hit perfect
		[52171]=0, -- stam perfect
		[52170]=0, -- spir perfect
		[52169]=0, -- spen perfect
		[52089]="addon.opt.allowImperfectUncommon and 2 or 0", -- hit uncommon
		[52086]=0, -- stam uncommon
		[52087]=0, -- spir uncommon
		[52088]=0, -- spen uncommon
		------------
		-- yellow --
		------------
		[52269]=2, -- mastery JC gem
		[52267]=0, -- resil JC gem
		[52268]=2, -- haste JC gem
		[52266]=2, -- crit JC gem
		[52265]=0, -- dodge JC gem
		[52219]=2, -- mastery rare
		[52226]=0, -- resil rare
		[52232]=2, -- haste rare
		[52241]=2, -- crit rare
		[52247]=0, -- dodge rare
		[52163]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery perfect
		[52165]=0, -- resil perfect
		[52164]="addon.opt.allowPerfectUncommon and 2 or 0", -- haste perfect
		[52166]="addon.opt.allowPerfectUncommon and 2 or 0", -- crit perfect
		[52167]=0, -- dodge perfect
		[52094]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery uncommon
		[52092]=0, -- resil uncommon
		[52093]="addon.opt.allowImperfectUncommon and 2 or 0", -- haste uncommon
		[52091]="addon.opt.allowImperfectUncommon and 2 or 0", -- crit uncommon
		[52090]=0, -- dodge uncommon
		------------
		-- purple --
		------------
		[52203]=2, -- hit/exp rare
		[52210]=0, -- parry/stam rare
		[52213]=1, -- str/hit rare
		[52220]=2, -- agil/hit rare
		[52221]=1, -- exp/stam rare
		[52236]=0, -- int/spi rare
		[52234]=0, -- parry/hit rare
		[52238]=1, -- agi/stam rare
		[52243]=0, -- str/stam rare
		[52248]=0, -- int/stam rare
		[52217]=0, -- int/hit rare
		[52152]="addon.opt.allowPerfectUncommon and 2 or 0", -- hit/exp perfect
		[52160]=0, -- parry/stam perfect
		[52156]="addon.opt.allowPerfectUncommon and 1 or 0", -- str/hit perfect
		[52155]="addon.opt.allowPerfectUncommon and 2 or 0", -- agi/hit perfect
		[52158]="addon.opt.allowPerfectUncommon and 1 or 0", -- exp/stam perfect
		[52157]=0, -- int/spirit perfect
		[52154]=0, -- parry/hit perfect
		[52161]="addon.opt.allowPerfectUncommon and 1 or 0", -- agi/stam perfect
		[52162]=0, -- str/stam perfect
		[52159]=0, -- int/stam perfect
		[52153]=0, -- int/hit perfect
		[52105]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp/hit uncommon
		[52097]=0, -- parry/stam uncommon
		[52101]="addon.opt.allowImperfectUncommon and 1 or 0", -- str/hit uncommon
		[52102]="addon.opt.allowImperfectUncommon and 2 or 0", -- agi/hit uncommon
		[52099]="addon.opt.allowImperfectUncommon and 1 or 0", -- exp/stam uncommon
		[52100]=0, -- int/spi uncommon
		[52103]=0, -- parry/hit uncommon
		[52096]="addon.opt.allowImperfectUncommon and 1 or 0", -- agi/stam uncommon
		[52095]=0, -- str/stam uncommon
		[52098]=0, -- int/stam uncommon
		[52104]=0, -- int/hit uncommon
		-----------
		-- green --
		-----------
		[52218]=1, -- haste/stam rare
		[52223]=1, -- crit/stam rare
		[52225]=2, -- haste/hit rare
		[52227]=0, -- dodge/hit rare
		[52228]=2, -- crit/hit rare
		[52231]=1, -- mastery/stam rare
		[52233]=0, -- dodge/stam rare
		[52237]=2, -- mastery/hit rare
		[52245]=0, -- resil/stam rare
		[52250]=0, -- mastery/spirit rare
		[52133]="addon.opt.allowPerfectUncommon and 1 or 0", -- haste/stam perfect
		[52136]="addon.opt.allowPerfectUncommon and 1 or 0", -- crit/stam perfect
		[52132]="addon.opt.allowPerfectUncommon and 2 or 0", -- haste/hit perfect
		[52137]=0, -- dodge/hit perfect
		[52135]="addon.opt.allowPerfectUncommon and 2 or 0", -- crit/hit perfect
		[52131]="addon.opt.allowPerfectUncommon and 1 or 0", -- mastery/stam perfect
		[52138]=0, -- dodge/stam perfect
		[52129]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery/hit perfect
		[52134]=0, -- resil/stam perfect
		[52130]=0, -- mastery/spirit perfect
		[52124]="addon.opt.allowImperfectUncommon and 1 or 0", -- haste/stam uncommon
		[52121]="addon.opt.allowImperfectUncommon and 1 or 0", -- crit/stam uncommon
		[52125]="addon.opt.allowImperfectUncommon and 2 or 0", -- haste/hit uncommon
		[52120]=0, -- dodge/hit uncommon
		[52122]="addon.opt.allowImperfectUncommon and 2 or 0", -- crit/hit uncommon
		[52126]="addon.opt.allowImperfectUncommon and 1 or 0", -- mastery/stam uncommon
		[52119]=0, -- dodge/stam uncommon
		[52128]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery/hit uncommon
		[52123]=0, -- resil/stam uncommon
		[52127]=0, -- mastery/spirit uncommon
		------------
		-- orange --
		------------
		[52204]=2, -- agil/mastery rare
		[52205]=0, -- int/mastery rare
		[52209]=2, -- agil/crit rare
		[52211]=2, -- agil/haste rare
		[52214]=1, -- str/haste rare
		[52215]=0, -- parry/mastery rare
		[52222]=1, -- str/crit rare
		[52224]=2, -- exp/mastery rare
		[68357]=1, -- agil/resil rare
		[52229]=1, -- agil/dodge rare
		[52239]=0, -- int/crit rare
		[52208]=0, -- int/haste rare
		[52249]=1, -- exp/dodge rare
		[68358]=0, -- str/resil rare
		[52240]=1, -- str/mastery rare
		[68356]=0, -- int/resil rare
		[52142]="addon.opt.allowPerfectUncommon and 2 or 0", -- agil/mastery perfect
		[52140]=0, -- int/mastery perfect
		[52148]="addon.opt.allowPerfectUncommon and 2 or 0", -- agil/crit perfect
		[52145]="addon.opt.allowPerfectUncommon and 2 or 0", -- agil/haste perfect
		[52146]="addon.opt.allowPerfectUncommon and 1 or 0", -- str/haste perfect
		[52141]=0, -- parry/mastery perfect
		[52149]="addon.opt.allowPerfectUncommon and 1 or 0", -- str/crit perfect
		[52139]="addon.opt.allowPerfectUncommon and 2 or 0", -- exp/mastery perfect
		[52151]="addon.opt.allowPerfectUncommon and 1 or 0", -- agil/dodge perfect
		[52147]=0, -- int/crit perfect
		[52144]=0, -- int/haste perfect
		[52150]="addon.opt.allowPerfectUncommon and 1 or 0", -- exp/dodge perfect
		[52143]="addon.opt.allowPerfectUncommon and 1 or 0", -- str/mastery perfect
		[52115]="addon.opt.allowImperfectUncommon and 2 or 0", -- agil/mastery uncommon
		[52117]=0, -- int/mastery uncommon
		[52109]="addon.opt.allowImperfectUncommon and 2 or 0", -- agil/crit uncommon
		[52112]="addon.opt.allowImperfectUncommon and 2 or 0", -- agil/haste uncommon
		[52111]="addon.opt.allowImperfectUncommon and 1 or 0", -- str/haste uncommon
		[52116]=0, -- parry/mastery uncommon
		[52108]="addon.opt.allowImperfectUncommon and 1 or 0", -- str/crit uncommon
		[52118]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp/mastery uncommon
		[52106]="addon.opt.allowImperfectUncommon and 1 or 0", -- agil/dodge uncommon
		[52110]=0, -- int/crit uncommon
		[52113]=0, -- int/haste uncommon
		[52107]="addon.opt.allowImperfectUncommon and 1 or 0", -- exp/dodge uncommon
		[52114]="addon.opt.allowImperfectUncommon and 1 or 0", -- str/mastery uncommon
		--------------
		-- cogwheel --
		--------------
		[59491]=0, -- parry
		[59480]=2, -- mastery
		[59489]=2, -- expertise
		[59479]=2, -- haste
		[59493]=2, -- hit
		[59478]=2, -- crit
		[59496]=0, -- spirit
		[59477]=0, -- dodge
	},
	enchanting = {
		noclass=0, -- non-listed are undesirable (X)
		----------
		-- back --
		----------
		[4064]=0, -- 70 spen
		[4072]=0, -- 30 int
		[4087]=2, -- 50 crit
		[4090]=0, -- 250 armor
		[4096]=0, -- 50 int
		[4100]=2, -- 65 crit
		[4116]=0, -- tailoring mana restore (darkglow)
		[4115]=0, -- tailoring spell power (lightweave)
		[4118]=2, -- tailoring attack power (swordguard)
		-----------
		-- chest --
		-----------
		[4063]=2, -- 15 stats
		[4070]=1, -- 55 stam
		[4077]=0, -- 40 resil
		[4088]=0, -- 40 spirit
		[4103]=1, -- 75 stam
		[4102]=2, -- 20 stats
		----------
		-- feet --
		----------
		[4062]=1, -- 30 stam and movespeed
		[4069]=2, -- 50 haste
		[4076]=2, -- 35 agi
		[4092]=2, -- 50 hit
		[4094]=2, -- 50 mastery
		[4105]=2, -- 25 agil and movespeed
		[4104]=2, -- 35 mastery and movespeed
		------------------------
		-- ring self-enchants --
		------------------------
		[4079]=2, -- agi
		[4081]=1, -- stam
		[4080]=0, -- int
		[4078]=1, -- str
		-----------
		-- hands --
		-----------
		[4061]=2, -- 50 mastery
		[4068]=2, -- 50 haste
		[4075]=1, -- 35 str
		[4082]=2, -- 50 exp
		[4107]=2, -- 65 mastery
		[4106]=1, -- 50 str
		[3246]=0, -- 28 sp
		[3253]=0, -- 2% threat 10 parry (armsman)
		----------
		-- head --
		----------
		[4208]=1, -- 60 str 35 mastery
		[4206]=0, -- 90 stam 35 dodge
		[4209]=2, -- 60 agil 35 haste
		[4207]=1, -- 60 int 35 crit
		--------------
		-- off-hand --
		--------------
		[4091]=0, -- 100 int
		------------
		-- weapon --
		------------
		[4067]=1, -- nature damage proc (avalanche)
		[4066]=0, -- heal proc [procs off dots] (mending)
		[4074]=1, -- arcane damage + silence proc only vs elementals (elemental slayer)
		[4083]=2, -- 450 haste proc (hurricane)
		[4084]=0, -- 200 spirit oncast proc (heartsong)
		[4099]=2, -- 1000 ap proc (landslide)
		[4097]=0, -- 500 int oncast proc (power torrent)
		[4098]=1, -- 600 dodge 15% movespeed proc (windwalk)
		[3834]=0, -- 63 sp
		[3830]=0, -- 50 sp
		------------
		-- ranged --
		------------
		[4177]=1, -- 88 ranged haste
		[4176]=1, -- 88 ranged hit
		[4175]=1, -- 800 ap ranged proc
		------------
		-- shield --
		------------
		[4085]=0, -- 40 block rating
		[4073]=0, -- 160 armor
		--------------
		-- shoulder --
		--------------
		[4197]=0, -- stam/dodge honored
		[4205]=2, -- agi/mastery honored
		[4201]=1, -- str/crit honored
		[4199]=0, -- int/haste honored
		[4198]=0, -- stam/dodge exalted
		[4204]=2, -- agi/mastery exalted
		[4202]=1, -- str/crit exalted
		[4200]=0, -- int/haste exalted
		[4193]=2, -- 130 agi 25 mastery (inscription self-enchant)
		[4196]=0, -- 130 int 25 haste (inscription self-enchant)
		[4195]=0, -- 195 stam 25 dodge (inscription self-enchant)
		[4194]=1, -- 130 str 25 crit (inscription self-enchant)
		---------------
		-- 2h weapon --
		---------------
		[4227]=2, -- 130 agi
		-----------
		-- wrist --
		-----------
		[4065]=2, -- 50 haste
		[4071]=2, -- 50 crit
		[4086]=0, -- 50 dodge
		[4089]=2, -- 50 hit
		[4093]=0, -- 50 spirit
		[4095]=2, -- 50 exp
		[4101]=2, -- 65 crit
		[4108]=2, -- 65 haste
		[4190]=2, -- 130 agi
		[4192]=0, -- 130 int
		[4189]=0, -- 195 stam
		[4191]=1, -- 130 str
		[2332]=0, -- 30 sp
		[3850]=0, -- 40 stam
		----------
		-- legs --
		----------
		[4127]=1, -- 145 stam 55 agi
		[4126]=2, -- 190 ap 55 crit
		[4112]=0, -- 95 int 80 stam
		[4113]=0, -- 95 int 80 stam tailoring
		[4110]=0, -- 95 int 55 spir
		[4124]=1, -- 85 stam 45 agi
		[4122]=2, -- 110 ap 45 crit
		[4111]=0, -- 55 int 65 stam
		[4109]=0, -- 55 int 45 spir
		-----------
		-- staff --
		-----------
		[3854]=0, -- 81 sp
		[3855]=0, -- 69 sp
	},
	stats = {
		noclass=0, -- non-listed are undesirable (X)
		inherits="Generic",
		ITEM_MOD_CRIT_RATING_SHORT=2, -- crit rating
		ITEM_MOD_MASTERY_RATING_SHORT=2, -- mastery
		ITEM_MOD_STRENGTH_SHORT=1, -- str
		ITEM_MOD_AGILITY_SHORT=2, -- agility
		ITEM_MOD_HASTE_RATING_SHORT=2, -- haste
		ITEM_MOD_SPELL_POWER_SHORT=0, -- spell power
		ITEM_MOD_SPIRIT_SHORT=0, -- spirit
		ITEM_MOD_INTELLECT_SHORT=0, -- intellect
		ITEM_MOD_SPELL_PENETRATION_SHORT=0, -- spell pen
		ITEM_MOD_RESILIENCE_RATING_SHORT=0, -- resil
		ITEM_MOD_HEALTH_REGEN_SHORT=1, -- hp regen
		ITEM_MOD_ATTACK_POWER_SHORT=2, -- ap
		ITEM_MOD_EXPERTISE_RATING_SHORT=2, -- exp
		ITEM_MOD_HIT_RATING_SHORT=2, -- hit
		ITEM_MOD_PARRY_RATING_SHORT=0, -- parry
		ITEM_MOD_DODGE_RATING_SHORT=0, -- dodge
	},
	noenchant={
		inherits="Generic",
	}
}



templates["Strength Melee"] = {
	gemming = {
		noclass=0, -- non-listed are undesirable (X)
		---------
		-- red --
		---------
		[52206]=2, -- str rare
		[52212]=1, -- agi rare
		[52207]=0, -- int rare
		[52216]=0, -- parry rare
		[52230]=2, -- exp rare
		[52255]=2, -- str JC gem
		[52257]=0, -- int JC gem
		[52258]=1, -- agi JC gem
		[52259]=0, -- parry JC gem
		[52260]=2, -- expertise JC gem
		[52176]="addon.opt.allowPerfectUncommon and 2 or 0", -- str perfect
		[52173]=0, -- int perfect
		[52175]="addon.opt.allowPerfectUncommon and 1 or 0", -- agi perfect
		[52174]=0, -- parry perfect
		[52172]="addon.opt.allowPerfectUncommon and 2 or 0", -- expertise perfect
		[52081]="addon.opt.allowImperfectUncommon and 2 or 0", -- str uncommon
		[52084]=0, -- int uncommon
		[52082]="addon.opt.allowImperfectUncommon and 1 or 0", -- agi uncommon
		[52083]=0, -- parry uncommon
		[52085]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp uncommon
		----------
		-- blue --
		----------
		[52261]=0, -- stam JC gem
		[52264]=2, -- hit jc gem
		[52262]=0, -- spir jc gem
		[52263]=0, -- spen jc gem
		[52235]=2, -- hit rare
		[52242]=0, -- stam rare
		[52244]=0, -- spir rare
		[52246]=0, -- spen rare
		[52168]="addon.opt.allowPerfectUncommon and 2 or 0", -- hit perfect
		[52171]=0, -- stam perfect
		[52170]=0, -- spir perfect
		[52169]=0, -- spen perfect
		[52089]="addon.opt.allowImperfectUncommon and 2 or 0", -- hit uncommon
		[52086]=0, -- stam uncommon
		[52087]=0, -- spir uncommon
		[52088]=0, -- spen uncommon
		------------
		-- yellow --
		------------
		[52269]=2, -- mastery JC gem
		[52267]=0, -- resil JC gem
		[52268]=2, -- haste JC gem
		[52266]=2, -- crit JC gem
		[52265]=0, -- dodge JC gem
		[52219]=2, -- mastery rare
		[52226]=0, -- resil rare
		[52232]=2, -- haste rare
		[52241]=2, -- crit rare
		[52247]=0, -- dodge rare
		[52163]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery perfect
		[52165]=0, -- resil perfect
		[52164]="addon.opt.allowPerfectUncommon and 2 or 0", -- haste perfect
		[52166]="addon.opt.allowPerfectUncommon and 2 or 0", -- crit perfect
		[52167]=0, -- dodge perfect
		[52094]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery uncommon
		[52092]=0, -- resil uncommon
		[52093]="addon.opt.allowImperfectUncommon and 2 or 0", -- haste uncommon
		[52091]="addon.opt.allowImperfectUncommon and 2 or 0", -- crit uncommon
		[52090]=0, -- dodge uncommon
		------------
		-- purple --
		------------
		[52203]=2, -- hit/exp rare
		[52210]=0, -- parry/stam rare
		[52213]=2, -- str/hit rare
		[52220]=1, -- agil/hit rare
		[52221]=1, -- exp/stam rare
		[52236]=0, -- int/spi rare
		[52234]=0, -- parry/hit rare
		[52238]=0, -- agi/stam rare
		[52243]=1, -- str/stam rare
		[52248]=0, -- int/stam rare
		[52217]=0, -- int/hit rare
		[52152]="addon.opt.allowPerfectUncommon and 2 or 0", -- hit/exp perfect
		[52160]=0, -- parry/stam perfect
		[52156]="addon.opt.allowPerfectUncommon and 2 or 0", -- str/hit perfect
		[52155]="addon.opt.allowPerfectUncommon and 1 or 0", -- agi/hit perfect
		[52158]="addon.opt.allowPerfectUncommon and 1 or 0", -- exp/stam perfect
		[52157]=0, -- int/spirit perfect
		[52154]=0, -- parry/hit perfect
		[52161]=0, -- agi/stam perfect
		[52162]="addon.opt.allowPerfectUncommon and 1 or 0", -- str/stam perfect
		[52159]=0, -- int/stam perfect
		[52153]=0, -- int/hit perfect
		[52105]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp/hit uncommon
		[52097]=0, -- parry/stam uncommon
		[52101]="addon.opt.allowImperfectUncommon and 2 or 0", -- str/hit uncommon
		[52102]="addon.opt.allowImperfectUncommon and 1 or 0", -- agi/hit uncommon
		[52099]="addon.opt.allowImperfectUncommon and 1 or 0", -- exp/stam uncommon
		[52100]=0, -- int/spi uncommon
		[52103]=0, -- parry/hit uncommon
		[52096]=0, -- agi/stam uncommon
		[52095]="addon.opt.allowImperfectUncommon and 1 or 0", -- str/stam uncommon
		[52098]=0, -- int/stam uncommon
		[52104]=0, -- int/hit uncommon
		-----------
		-- green --
		-----------
		[52218]=1, -- haste/stam rare
		[52223]=1, -- crit/stam rare
		[52225]=2, -- haste/hit rare
		[52227]=0, -- dodge/hit rare
		[52228]=2, -- crit/hit rare
		[52231]=1, -- mastery/stam rare
		[52233]=0, -- dodge/stam rare
		[52237]=2, -- mastery/hit rare
		[52245]=0, -- resil/stam rare
		[52250]=0, -- mastery/spirit rare
		[52133]="addon.opt.allowPerfectUncommon and 1 or 0", -- haste/stam perfect
		[52136]="addon.opt.allowPerfectUncommon and 1 or 0", -- crit/stam perfect
		[52132]="addon.opt.allowPerfectUncommon and 2 or 0", -- haste/hit perfect
		[52137]=0, -- dodge/hit perfect
		[52135]="addon.opt.allowPerfectUncommon and 2 or 0", -- crit/hit perfect
		[52131]="addon.opt.allowPerfectUncommon and 1 or 0", -- mastery/stam perfect
		[52138]=0, -- dodge/stam perfect
		[52129]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery/hit perfect
		[52134]=0, -- resil/stam perfect
		[52130]=0, -- mastery/spirit perfect
		[52124]="addon.opt.allowImperfectUncommon and 1 or 0", -- haste/stam uncommon
		[52121]="addon.opt.allowImperfectUncommon and 1 or 0", -- crit/stam uncommon
		[52125]="addon.opt.allowImperfectUncommon and 2 or 0", -- haste/hit uncommon
		[52120]=0, -- dodge/hit uncommon
		[52122]="addon.opt.allowImperfectUncommon and 2 or 0", -- crit/hit uncommon
		[52126]="addon.opt.allowImperfectUncommon and 1 or 0", -- mastery/stam uncommon
		[52119]=0, -- dodge/stam uncommon
		[52128]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery/hit uncommon
		[52123]=0, -- resil/stam uncommon
		[52127]=0, -- mastery/spirit uncommon
		------------
		-- orange --
		------------
		[52204]=1, -- agil/mastery rare
		[52205]=0, -- int/mastery rare
		[52209]=1, -- agil/crit rare
		[52211]=1, -- agil/haste rare
		[52214]=2, -- str/haste rare
		[52215]=0, -- parry/mastery rare
		[52222]=2, -- str/crit rare
		[52224]=2, -- exp/mastery rare
		[68357]=0, -- agil/resil rare
		[52229]=0, -- agil/dodge rare
		[52239]=0, -- int/crit rare
		[52208]=0, -- int/haste rare
		[52249]=1, -- exp/dodge rare
		[68358]=1, -- str/resil rare
		[52240]=2, -- str/mastery rare
		[68356]=0, -- int/resil rare
		[52142]="addon.opt.allowPerfectUncommon and 1 or 0", -- agil/mastery perfect
		[52140]=0, -- int/mastery perfect
		[52148]="addon.opt.allowPerfectUncommon and 1 or 0", -- agil/crit perfect
		[52145]="addon.opt.allowPerfectUncommon and 1 or 0", -- agil/haste perfect
		[52146]="addon.opt.allowPerfectUncommon and 2 or 0", -- str/haste perfect
		[52141]=0, -- parry/mastery perfect
		[52149]="addon.opt.allowPerfectUncommon and 2 or 0", -- str/crit perfect
		[52139]="addon.opt.allowPerfectUncommon and 2 or 0", -- exp/mastery perfect
		[52151]=0, -- agil/dodge perfect
		[52147]=0, -- int/crit perfect
		[52144]=0, -- int/haste perfect
		[52150]="addon.opt.allowPerfectUncommon and 1 or 0", -- exp/dodge perfect
		[52143]="addon.opt.allowPerfectUncommon and 2 or 0", -- str/mastery perfect
		[52115]="addon.opt.allowImperfectUncommon and 1 or 0", -- agil/mastery uncommon
		[52117]=0, -- int/mastery uncommon
		[52109]="addon.opt.allowImperfectUncommon and 1 or 0", -- agil/crit uncommon
		[52112]="addon.opt.allowImperfectUncommon and 1 or 0", -- agil/haste uncommon
		[52111]="addon.opt.allowImperfectUncommon and 2 or 0", -- str/haste uncommon
		[52116]=0, -- parry/mastery uncommon
		[52108]="addon.opt.allowImperfectUncommon and 2 or 0", -- str/crit uncommon
		[52118]="addon.opt.allowImperfectUncommon and 2 or 0", -- exp/mastery uncommon
		[52106]=0, -- agil/dodge uncommon
		[52110]=0, -- int/crit uncommon
		[52113]=0, -- int/haste uncommon
		[52107]="addon.opt.allowImperfectUncommon and 1 or 0", -- exp/dodge uncommon
		[52114]="addon.opt.allowImperfectUncommon and 2 or 0", -- str/mastery uncommon
		--------------
		-- cogwheel --
		--------------
		[59491]=0, -- parry
		[59480]=2, -- mastery
		[59489]=2, -- expertise
		[59479]=2, -- haste
		[59493]=2, -- hit
		[59478]=2, -- crit
		[59496]=0, -- spirit
		[59477]=0, -- dodge
	},
	enchanting = {
		noclass=0, -- non-listed are undesirable (X)
		----------
		-- back --
		----------
		[4064]=0, -- 70 spen
		[4072]=0, -- 30 int
		[4087]=2, -- 50 crit
		[4090]=0, -- 250 armor
		[4096]=0, -- 50 int
		[4100]=2, -- 65 crit
		[4116]=0, -- tailoring mana restore (darkglow)
		[4115]=0, -- tailoring spell power (lightweave)
		[4118]=2, -- tailoring attack power (swordguard)
		-----------
		-- chest --
		-----------
		[4063]=2, -- 15 stats
		[4070]=1, -- 55 stam
		[4077]=0, -- 40 resil
		[4088]=0, -- 40 spirit
		[4103]=1, -- 75 stam
		[4102]=2, -- 20 stats
		----------
		-- feet --
		----------
		[4062]=1, -- 30 stam and movespeed
		[4069]=2, -- 50 haste
		[4076]=1, -- 35 agi
		[4092]=2, -- 50 hit
		[4094]=2, -- 50 mastery
		[4105]=1, -- 25 agil and movespeed
		[4104]=2, -- 35 mastery and movespeed
		------------------------
		-- ring self-enchants --
		------------------------
		[4079]=1, -- agi
		[4081]=1, -- stam
		[4080]=0, -- int
		[4078]=2, -- str
		-----------
		-- hands --
		-----------
		[4061]=2, -- 50 mastery
		[4068]=2, -- 50 haste
		[4075]=2, -- 35 str
		[4082]=2, -- 50 exp
		[4107]=2, -- 65 mastery
		[4106]=2, -- 50 str
		[3246]=0, -- 28 sp
		[3253]=0, -- 2% threat 10 parry (armsman)
		----------
		-- head --
		----------
		[4208]=2, -- 60 str 35 mastery
		[4206]=0, -- 90 stam 35 dodge
		[4209]=1, -- 60 agil 35 haste
		[4207]=1, -- 60 int 35 crit
		--------------
		-- off-hand --
		--------------
		[4091]=0, -- 100 int
		------------
		-- weapon --
		------------
		[4067]=1, -- nature damage proc (avalanche)
		[4066]=0, -- heal proc [procs off dots] (mending)
		[4074]=1, -- arcane damage + silence proc only vs elementals (elemental slayer)
		[4083]=2, -- 450 haste proc (hurricane)
		[4084]=0, -- 200 spirit oncast proc (heartsong)
		[4099]=2, -- 1000 ap proc (landslide)
		[4097]=0, -- 500 int oncast proc (power torrent)
		[4098]=1, -- 600 dodge 15% movespeed proc (windwalk)
		[3834]=0, -- 63 sp
		[3830]=0, -- 50 sp
		------------
		-- ranged --
		------------
		[4177]=1, -- 88 ranged haste
		[4176]=1, -- 88 ranged hit
		[4175]=1, -- 800 ap ranged proc
		------------
		-- shield --
		------------
		[4085]=0, -- 40 block rating
		[4073]=0, -- 160 armor
		--------------
		-- shoulder --
		--------------
		[4197]=0, -- stam/dodge honored
		[4205]=1, -- agi/mastery honored
		[4201]=2, -- str/crit honored
		[4199]=0, -- int/haste honored
		[4198]=0, -- stam/dodge exalted
		[4204]=1, -- agi/mastery exalted
		[4202]=2, -- str/crit exalted
		[4200]=0, -- int/haste exalted
		[4193]=1, -- 130 agi 25 mastery (inscription self-enchant)
		[4196]=0, -- 130 int 25 haste (inscription self-enchant)
		[4195]=0, -- 195 stam 25 dodge (inscription self-enchant)
		[4194]=2, -- 130 str 25 crit (inscription self-enchant)
		---------------
		-- 2h weapon --
		---------------
		[4227]=1, -- 130 agi
		-----------
		-- wrist --
		-----------
		[4065]=2, -- 50 haste
		[4071]=2, -- 50 crit
		[4086]=0, -- 50 dodge
		[4089]=2, -- 50 hit
		[4093]=0, -- 50 spirit
		[4095]=2, -- 50 exp
		[4101]=2, -- 65 crit
		[4108]=2, -- 65 haste
		[4190]=1, -- 130 agi
		[4192]=0, -- 130 int
		[4189]=0, -- 195 stam
		[4191]=2, -- 130 str
		[2332]=0, -- 30 sp
		[3850]=0, -- 40 stam
		----------
		-- legs --
		----------
		[4127]=1, -- 145 stam 55 agi
		[4126]=2, -- 190 ap 55 crit
		[4112]=0, -- 95 int 80 stam
		[4113]=0, -- 95 int 80 stam tailoring
		[4110]=0, -- 95 int 55 spir
		[4124]=1, -- 85 stam 45 agi
		[4122]=2, -- 110 ap 45 crit
		[4111]=0, -- 55 int 65 stam
		[4109]=0, -- 55 int 45 spir
		-----------
		-- staff --
		-----------
		[3854]=0, -- 81 sp
		[3855]=0, -- 69 sp
	},
	stats = {
		noclass=0, -- non-listed are undesirable (X)
		inherits="Generic",
		ITEM_MOD_CRIT_RATING_SHORT=2, -- crit rating
		ITEM_MOD_MASTERY_RATING_SHORT=2, -- mastery
		ITEM_MOD_STRENGTH_SHORT=2, -- str
		ITEM_MOD_AGILITY_SHORT=1, -- agility
		ITEM_MOD_HASTE_RATING_SHORT=2, -- haste
		ITEM_MOD_SPELL_POWER_SHORT=0, -- spell power
		ITEM_MOD_SPIRIT_SHORT=0, -- spirit
		ITEM_MOD_INTELLECT_SHORT=0, -- intellect
		ITEM_MOD_SPELL_PENETRATION_SHORT=0, -- spell pen
		ITEM_MOD_RESILIENCE_RATING_SHORT=0, -- resil
		ITEM_MOD_HEALTH_REGEN_SHORT=1, -- hp regen
		ITEM_MOD_ATTACK_POWER_SHORT=1, -- ap
		ITEM_MOD_EXPERTISE_RATING_SHORT=2, -- exp
		ITEM_MOD_HIT_RATING_SHORT=2, -- hit
		ITEM_MOD_PARRY_RATING_SHORT=0	, -- parry
		ITEM_MOD_DODGE_RATING_SHORT=0, -- dodge
	},
	noenchant={
		inherits="Generic",
	}
}



templates["Non-spirit Caster"] = {
	gemming = {
		noclass=0, -- non-listed are undesirable (X)
		---------
		-- red --
		---------
		[52206]=0, -- str rare
		[52212]=0, -- agi rare
		[52207]=2, -- int rare
		[52216]=0, -- parry rare
		[52230]=0, -- exp rare
		[52255]=0, -- str JC gem
		[52257]=2, -- int JC gem
		[52258]=0, -- agi JC gem
		[52259]=0, -- parry JC gem
		[52260]=0, -- expertise JC gem
		[52176]=0, -- str perfect
		[52173]="addon.opt.allowPerfectUncommon and 2 or 0", -- int perfect
		[52175]=0, -- agi perfect
		[52174]=0, -- parry perfect
		[52172]=0, -- expertise perfect
		[52081]=0, -- str uncommon
		[52084]="addon.opt.allowImperfectUncommon and 2 or 0", -- int uncommon
		[52082]=0, -- agi uncommon
		[52083]=0, -- parry uncommon
		[52085]=0, -- exp uncommon
		----------
		-- blue --
		----------
		[52261]=0, -- stam JC gem
		[52264]=2, -- hit jc gem
		[52262]=1, -- spir jc gem
		[52263]=0, -- spen jc gem
		[52235]=2, -- hit rare
		[52242]=0, -- stam rare
		[52244]=1, -- spir rare
		[52246]=0, -- spen rare
		[52168]="addon.opt.allowPerfectUncommon and 2 or 0", -- hit perfect
		[52171]=0, -- stam perfect
		[52170]="addon.opt.allowPerfectUncommon and 1 or 0", -- spir perfect
		[52169]=0, -- spen perfect
		[52089]="addon.opt.allowImperfectUncommon and 2 or 0", -- hit uncommon
		[52086]=0, -- stam uncommon
		[52087]="addon.opt.allowImperfectUncommon and 1 or 0", -- spir uncommon
		[52088]=0, -- spen uncommon
		------------
		-- yellow --
		------------
		[52269]=2, -- mastery JC gem
		[52267]=0, -- resil JC gem
		[52268]=2, -- haste JC gem
		[52266]=2, -- crit JC gem
		[52265]=0, -- dodge JC gem
		[52219]=2, -- mastery rare
		[52226]=0, -- resil rare
		[52232]=2, -- haste rare
		[52241]=2, -- crit rare
		[52247]=0, -- dodge rare
		[52163]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery perfect
		[52165]=0, -- resil perfect
		[52164]="addon.opt.allowPerfectUncommon and 2 or 0", -- haste perfect
		[52166]="addon.opt.allowPerfectUncommon and 2 or 0", -- crit perfect
		[52167]=0, -- dodge perfect
		[52094]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery uncommon
		[52092]=0, -- resil uncommon
		[52093]="addon.opt.allowImperfectUncommon and 2 or 0", -- haste uncommon
		[52091]="addon.opt.allowImperfectUncommon and 2 or 0", -- crit uncommon
		[52090]=0, -- dodge uncommon
		------------
		-- purple --
		------------
		[52203]=0, -- hit/exp rare
		[52210]=0, -- parry/stam rare
		[52213]=0, -- str/hit rare
		[52220]=0, -- agil/hit rare
		[52221]=0, -- exp/stam rare
		[52236]=1, -- int/spi rare
		[52234]=0, -- parry/hit rare
		[52238]=0, -- agi/stam rare
		[52243]=0, -- str/stam rare
		[52248]=1, -- int/stam rare
		[52217]=2, -- int/hit rare
		[52152]=0, -- hit/exp perfect
		[52160]=0, -- parry/stam perfect
		[52156]=0, -- str/hit perfect
		[52155]=0, -- agi/hit perfect
		[52158]=0, -- exp/stam perfect
		[52157]="addon.opt.allowPerfectUncommon and 1 or 0", -- int/spirit perfect
		[52154]=0, -- parry/hit perfect
		[52161]=0, -- agi/stam perfect
		[52162]=0, -- str/stam perfect
		[52159]="addon.opt.allowPerfectUncommon and 1 or 0", -- int/stam perfect
		[52153]="addon.opt.allowPerfectUncommon and 2 or 0", -- int/hit perfect
		[52105]=0, -- exp/hit uncommon
		[52097]=0, -- parry/stam uncommon
		[52101]=0, -- str/hit uncommon
		[52102]=0, -- agi/hit uncommon
		[52099]=0, -- exp/stam uncommon
		[52100]="addon.opt.allowImperfectUncommon and 1 or 0", -- int/spi uncommon
		[52103]=0, -- parry/hit uncommon
		[52096]=0, -- agi/stam uncommon
		[52095]=0, -- str/stam uncommon
		[52098]=1, -- int/stam uncommon
		[52104]=2, -- int/hit uncommon
		-----------
		-- green --
		-----------
		[52218]=1, -- haste/stam rare
		[52223]=1, -- crit/stam rare
		[52225]=2, -- haste/hit rare
		[52227]=0, -- dodge/hit rare
		[52228]=2, -- crit/hit rare
		[52231]=1, -- mastery/stam rare
		[52233]=0, -- dodge/stam rare
		[52237]=2, -- mastery/hit rare
		[52245]=0, -- resil/stam rare
		[52250]=0, -- mastery/spirit rare
		[52133]="addon.opt.allowPerfectUncommon and 1 or 0", -- haste/stam perfect
		[52136]="addon.opt.allowPerfectUncommon and 1 or 0", -- crit/stam perfect
		[52132]="addon.opt.allowPerfectUncommon and 2 or 0", -- haste/hit perfect
		[52137]=0, -- dodge/hit perfect
		[52135]="addon.opt.allowPerfectUncommon and 2 or 0", -- crit/hit perfect
		[52131]="addon.opt.allowPerfectUncommon and 1 or 0", -- mastery/stam perfect
		[52138]=0, -- dodge/stam perfect
		[52129]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery/hit perfect
		[52134]=0, -- resil/stam perfect
		[52130]=0, -- mastery/spirit perfect
		[52124]="addon.opt.allowImperfectUncommon and 1 or 0", -- haste/stam uncommon
		[52121]="addon.opt.allowImperfectUncommon and 1 or 0", -- crit/stam uncommon
		[52125]="addon.opt.allowImperfectUncommon and 2 or 0", -- haste/hit uncommon
		[52120]=0, -- dodge/hit uncommon
		[52122]="addon.opt.allowImperfectUncommon and 2 or 0", -- crit/hit uncommon
		[52126]="addon.opt.allowImperfectUncommon and 1 or 0", -- mastery/stam uncommon
		[52119]=0, -- dodge/stam uncommon
		[52128]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery/hit uncommon
		[52123]=0, -- resil/stam uncommon
		[52127]=0, -- mastery/spirit uncommon
		------------
		-- orange --
		------------
		[52204]=0, -- agil/mastery rare
		[52205]=2, -- int/mastery rare
		[52209]=0, -- agil/crit rare
		[52211]=0, -- agil/haste rare
		[52214]=0, -- str/haste rare
		[52215]=0, -- parry/mastery rare
		[52222]=0, -- str/crit rare
		[52224]=0, -- exp/mastery rare
		[68357]=0, -- agil/resil rare
		[52229]=0, -- agil/dodge rare
		[52239]=2, -- int/crit rare
		[52208]=2, -- int/haste rare
		[52249]=0, -- exp/dodge rare
		[68358]=0, -- str/resil rare
		[52240]=0, -- str/mastery rare
		[68356]=1, -- int/resil rare
		[52142]=0, -- agil/mastery perfect
		[52140]="addon.opt.allowPerfectUncommon and 2 or 0", -- int/mastery perfect
		[52148]=0, -- agil/crit perfect
		[52145]=0, -- agil/haste perfect
		[52146]=0, -- str/haste perfect
		[52141]=0, -- parry/mastery perfect
		[52149]=0, -- str/crit perfect
		[52139]=0, -- exp/mastery perfect
		[52151]=0, -- agil/dodge perfect
		[52147]="addon.opt.allowPerfectUncommon and 2 or 0", -- int/crit perfect
		[52144]="addon.opt.allowPerfectUncommon and 2 or 0", -- int/haste perfect
		[52150]=0, -- exp/dodge perfect
		[52143]=0, -- str/mastery perfect
		[52115]=0, -- agil/mastery uncommon
		[52117]="addon.opt.allowImperfectUncommon and 2 or 0", -- int/mastery uncommon
		[52109]=0, -- agil/crit uncommon
		[52112]=0, -- agil/haste uncommon
		[52111]=0, -- str/haste uncommon
		[52116]=0, -- parry/mastery uncommon
		[52108]=0, -- str/crit uncommon
		[52118]=0, -- exp/mastery uncommon
		[52106]=0, -- agil/dodge uncommon
		[52110]="addon.opt.allowImperfectUncommon and 2 or 0", -- int/crit uncommon
		[52113]="addon.opt.allowImperfectUncommon and 2 or 0", -- int/haste uncommon
		[52107]=0, -- exp/dodge uncommon
		[52114]=0, -- str/mastery uncommon
		--------------
		-- cogwheel --
		--------------
		[59491]=0, -- parry
		[59480]=2, -- mastery
		[59489]=0, -- expertise
		[59479]=2, -- haste
		[59493]=2, -- hit
		[59478]=2, -- crit
		[59496]=1, -- spirit
		[59477]=0, -- dodge
	},
	enchanting = {
		noclass=0, -- non-listed are undesirable (X)
		----------
		-- back --
		----------
		[4064]=0, -- 70 spen
		[4072]=2, -- 30 int
		[4087]=2, -- 50 crit
		[4090]=0, -- 250 armor
		[4096]=2, -- 50 int
		[4100]=2, -- 65 crit
		[4116]=1, -- tailoring mana restore (darkglow)
		[4115]=2, -- tailoring spell power (lightweave)
		[4118]=0, -- tailoring attack power (swordguard)
		-----------
		-- chest --
		-----------
		[4063]=2, -- 15 stats
		[4070]=1, -- 55 stam
		[4077]=0, -- 40 resil
		[4088]=1, -- 40 spirit
		[4103]=1, -- 75 stam
		[4102]=2, -- 20 stats
		----------
		-- feet --
		----------
		[4062]=2, -- 30 stam and movespeed
		[4069]=2, -- 50 haste
		[4076]=1, -- 35 agi
		[4092]=2, -- 50 hit
		[4094]=2, -- 50 mastery
		[4105]=1, -- 25 agil and movespeed
		[4104]=2, -- 35 mastery and movespeed
		------------------------
		-- ring self-enchants --
		------------------------
		[4079]=0, -- agi
		[4081]=1, -- stam
		[4080]=2, -- int
		[4078]=0, -- str
		-----------
		-- hands --
		-----------
		[4061]=2, -- 50 mastery
		[4068]=2, -- 50 haste
		[4075]=0, -- 35 str
		[4082]=0, -- 50 exp
		[4107]=2, -- 65 mastery
		[4106]=0, -- 50 str
		[3246]=2, -- 28 sp
		[3253]=0, -- 2% threat 10 parry (armsman)
		----------
		-- head --
		----------
		[4208]=0, -- 60 str 35 mastery
		[4206]=0, -- 90 stam 35 dodge
		[4209]=0, -- 60 agil 35 haste
		[4207]=2, -- 60 int 35 crit
		--------------
		-- off-hand --
		--------------
		[4091]=2, -- 100 int
		------------
		-- weapon --
		------------
		[4067]=0, -- nature damage proc (avalanche)
		[4066]=0, -- heal proc [procs off dots] (mending)
		[4074]=0, -- arcane damage + silence proc only vs elementals (elemental slayer)
		[4083]=2, -- 450 haste proc (hurricane)
		[4084]=1, -- 200 spirit oncast proc (heartsong)
		[4099]=0, -- 1000 ap proc (landslide)
		[4097]=2, -- 500 int oncast proc (power torrent)
		[4098]=0, -- 600 dodge 15% movespeed proc (windwalk)
		[3834]=2, -- 63 sp
		[3830]=1, -- 50 sp
		------------
		-- ranged --
		------------
		[4177]=0, -- 88 ranged haste
		[4176]=0, -- 88 ranged hit
		[4175]=0, -- 800 ap ranged proc
		------------
		-- shield --
		------------
		[4085]=0, -- 40 block rating
		[4073]=0, -- 160 armor
		--------------
		-- shoulder --
		--------------
		[4197]=0, -- stam/dodge honored
		[4205]=0, -- agi/mastery honored
		[4201]=0, -- str/crit honored
		[4199]=2, -- int/haste honored
		[4198]=0, -- stam/dodge exalted
		[4204]=0, -- agi/mastery exalted
		[4202]=0, -- str/crit exalted
		[4200]=2, -- int/haste exalted
		[4193]=0, -- 130 agi 25 mastery (inscription self-enchant)
		[4196]=2, -- 130 int 25 haste (inscription self-enchant)
		[4195]=0, -- 195 stam 25 dodge (inscription self-enchant)
		[4194]=0, -- 130 str 25 crit (inscription self-enchant)
		---------------
		-- 2h weapon --
		---------------
		[4227]=0, -- 130 agi
		-----------
		-- wrist --
		-----------
		[4065]=2, -- 50 haste
		[4071]=2, -- 50 crit
		[4086]=0, -- 50 dodge
		[4089]=2, -- 50 hit
		[4093]=1, -- 50 spirit
		[4095]=0, -- 50 exp
		[4101]=2, -- 65 crit
		[4108]=2, -- 65 haste
		[4190]=0, -- 130 agi
		[4192]=2, -- 130 int
		[4189]=0, -- 195 stam
		[4191]=0, -- 130 str
		[2332]=2, -- 30 sp
		[3850]=0, -- 40 stam
		----------
		-- legs --
		----------
		[4127]=0, -- 145 stam 55 agi
		[4126]=0, -- 190 ap 55 crit
		[4112]=2, -- 95 int 80 stam
		[4113]=2, -- 95 int 80 stam tailoring
		[4110]=1, -- 95 int 55 spir
		[4124]=0, -- 85 stam 45 agi
		[4122]=0, -- 110 ap 45 crit
		[4111]=2, -- 55 int 65 stam
		[4109]=1, -- 55 int 45 spir
		-----------
		-- staff --
		-----------
		[3854]=2, -- 81 sp
		[3855]=1, -- 69 sp
	},
	stats = {
		noclass=0, -- non-listed are undesirable (X)
		inherits="Generic",
		ITEM_MOD_CRIT_RATING_SHORT=2, -- crit rating
		ITEM_MOD_MASTERY_RATING_SHORT=2, -- mastery
		ITEM_MOD_STRENGTH_SHORT=0, -- str
		ITEM_MOD_AGILITY_SHORT=0, -- agility
		ITEM_MOD_HASTE_RATING_SHORT=2, -- haste
		ITEM_MOD_SPELL_POWER_SHORT=2, -- spell power
		ITEM_MOD_SPIRIT_SHORT=1, -- spirit
		ITEM_MOD_INTELLECT_SHORT=2, -- intellect
		ITEM_MOD_SPELL_PENETRATION_SHORT=1, -- spell pen
		ITEM_MOD_RESILIENCE_RATING_SHORT=0, -- resil
		ITEM_MOD_HEALTH_REGEN_SHORT=0, -- hp regen
		ITEM_MOD_ATTACK_POWER_SHORT=0, -- ap
		ITEM_MOD_EXPERTISE_RATING_SHORT=0, -- exp
		ITEM_MOD_HIT_RATING_SHORT=2, -- hit
		ITEM_MOD_PARRY_RATING_SHORT=0, -- parry
		ITEM_MOD_DODGE_RATING_SHORT=0, -- dodge
	},
	noenchant={
		inherits="Generic",
	}
}

templates["Spirit Caster"] = {
	gemming = {
		noclass=0, -- non-listed are undesirable (X)
		---------
		-- red --
		---------
		[52206]=0, -- str rare
		[52212]=0, -- agi rare
		[52207]=2, -- int rare
		[52216]=0, -- parry rare
		[52230]=0, -- exp rare
		[52255]=0, -- str JC gem
		[52257]=2, -- int JC gem
		[52258]=0, -- agi JC gem
		[52259]=0, -- parry JC gem
		[52260]=0, -- expertise JC gem
		[52176]=0, -- str perfect
		[52173]="addon.opt.allowPerfectUncommon and 2 or 0", -- int perfect
		[52175]=0, -- agi perfect
		[52174]=0, -- parry perfect
		[52172]=0, -- expertise perfect
		[52081]=0, -- str uncommon
		[52084]="addon.opt.allowImperfectUncommon and 2 or 0", -- int uncommon
		[52082]=0, -- agi uncommon
		[52083]=0, -- parry uncommon
		[52085]=0, -- exp uncommon
		----------
		-- blue --
		----------
		[52261]=0, -- stam JC gem
		[52264]=2, -- hit jc gem
		[52262]=2, -- spir jc gem
		[52263]=0, -- spen jc gem
		[52235]=2, -- hit rare
		[52242]=0, -- stam rare
		[52244]=2, -- spir rare
		[52246]=0, -- spen rare
		[52168]="addon.opt.allowPerfectUncommon and 2 or 0", -- hit perfect
		[52171]=0, -- stam perfect
		[52170]="addon.opt.allowPerfectUncommon and 2 or 0", -- spir perfect
		[52169]=0, -- spen perfect
		[52089]="addon.opt.allowImperfectUncommon and 2 or 0", -- hit uncommon
		[52086]=0, -- stam uncommon
		[52087]="addon.opt.allowImperfectUncommon and 2 or 0", -- spir uncommon
		[52088]=0, -- spen uncommon
		------------
		-- yellow --
		------------
		[52269]=2, -- mastery JC gem
		[52267]=0, -- resil JC gem
		[52268]=2, -- haste JC gem
		[52266]=2, -- crit JC gem
		[52265]=0, -- dodge JC gem
		[52219]=2, -- mastery rare
		[52226]=0, -- resil rare
		[52232]=2, -- haste rare
		[52241]=2, -- crit rare
		[52247]=0, -- dodge rare
		[52163]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery perfect
		[52165]=0, -- resil perfect
		[52164]="addon.opt.allowPerfectUncommon and 2 or 0", -- haste perfect
		[52166]="addon.opt.allowPerfectUncommon and 2 or 0", -- crit perfect
		[52167]=0, -- dodge perfect
		[52094]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery uncommon
		[52092]=0, -- resil uncommon
		[52093]="addon.opt.allowImperfectUncommon and 2 or 0", -- haste uncommon
		[52091]="addon.opt.allowImperfectUncommon and 2 or 0", -- crit uncommon
		[52090]=0, -- dodge uncommon
		------------
		-- purple --
		------------
		[52203]=0, -- hit/exp rare
		[52210]=0, -- parry/stam rare
		[52213]=0, -- str/hit rare
		[52220]=0, -- agil/hit rare
		[52221]=0, -- exp/stam rare
		[52236]=2, -- int/spi rare
		[52234]=0, -- parry/hit rare
		[52238]=0, -- agi/stam rare
		[52243]=0, -- str/stam rare
		[52248]=1, -- int/stam rare
		[52217]=2, -- int/hit rare
		[52152]=0, -- hit/exp perfect
		[52160]=0, -- parry/stam perfect
		[52156]=0, -- str/hit perfect
		[52155]=0, -- agi/hit perfect
		[52158]=0, -- exp/stam perfect
		[52157]="addon.opt.allowPerfectUncommon and 2 or 0", -- int/spirit perfect
		[52154]=0, -- parry/hit perfect
		[52161]=0, -- agi/stam perfect
		[52162]=0, -- str/stam perfect
		[52159]="addon.opt.allowPerfectUncommon and 1 or 0", -- int/stam perfect
		[52153]="addon.opt.allowPerfectUncommon and 2 or 0", -- int/hit perfect
		[52105]=0, -- exp/hit uncommon
		[52097]=0, -- parry/stam uncommon
		[52101]=0, -- str/hit uncommon
		[52102]=0, -- agi/hit uncommon
		[52099]=0, -- exp/stam uncommon
		[52100]="addon.opt.allowImperfectUncommon and 2 or 0", -- int/spi uncommon
		[52103]=0, -- parry/hit uncommon
		[52096]=0, -- agi/stam uncommon
		[52095]=0, -- str/stam uncommon
		[52098]=1, -- int/stam uncommon
		[52104]=2, -- int/hit uncommon
		-----------
		-- green --
		-----------
		[52218]=1, -- haste/stam rare
		[52223]=1, -- crit/stam rare
		[52225]=2, -- haste/hit rare
		[52227]=0, -- dodge/hit rare
		[52228]=2, -- crit/hit rare
		[52231]=1, -- mastery/stam rare
		[52233]=0, -- dodge/stam rare
		[52237]=2, -- mastery/hit rare
		[52245]=0, -- resil/stam rare
		[52250]=2, -- mastery/spirit rare
		[52133]="addon.opt.allowPerfectUncommon and 1 or 0", -- haste/stam perfect
		[52136]="addon.opt.allowPerfectUncommon and 1 or 0", -- crit/stam perfect
		[52132]="addon.opt.allowPerfectUncommon and 2 or 0", -- haste/hit perfect
		[52137]=0, -- dodge/hit perfect
		[52135]="addon.opt.allowPerfectUncommon and 2 or 0", -- crit/hit perfect
		[52131]="addon.opt.allowPerfectUncommon and 1 or 0", -- mastery/stam perfect
		[52138]=0, -- dodge/stam perfect
		[52129]="addon.opt.allowPerfectUncommon and 2 or 0", -- mastery/hit perfect
		[52134]=0, -- resil/stam perfect
		[52130]=2, -- mastery/spirit perfect
		[52124]="addon.opt.allowImperfectUncommon and 1 or 0", -- haste/stam uncommon
		[52121]="addon.opt.allowImperfectUncommon and 1 or 0", -- crit/stam uncommon
		[52125]="addon.opt.allowImperfectUncommon and 2 or 0", -- haste/hit uncommon
		[52120]=0, -- dodge/hit uncommon
		[52122]="addon.opt.allowImperfectUncommon and 2 or 0", -- crit/hit uncommon
		[52126]="addon.opt.allowImperfectUncommon and 1 or 0", -- mastery/stam uncommon
		[52119]=0, -- dodge/stam uncommon
		[52128]="addon.opt.allowImperfectUncommon and 2 or 0", -- mastery/hit uncommon
		[52123]=0, -- resil/stam uncommon
		[52127]=2, -- mastery/spirit uncommon
		------------
		-- orange --
		------------
		[52204]=0, -- agil/mastery rare
		[52205]=2, -- int/mastery rare
		[52209]=0, -- agil/crit rare
		[52211]=0, -- agil/haste rare
		[52214]=0, -- str/haste rare
		[52215]=0, -- parry/mastery rare
		[52222]=0, -- str/crit rare
		[52224]=0, -- exp/mastery rare
		[68357]=0, -- agil/resil rare
		[52229]=0, -- agil/dodge rare
		[52239]=2, -- int/crit rare
		[52208]=2, -- int/haste rare
		[52249]=0, -- exp/dodge rare
		[68358]=0, -- str/resil rare
		[52240]=0, -- str/mastery rare
		[68356]=1, -- int/resil rare
		[52142]=0, -- agil/mastery perfect
		[52140]="addon.opt.allowPerfectUncommon and 2 or 0", -- int/mastery perfect
		[52148]=0, -- agil/crit perfect
		[52145]=0, -- agil/haste perfect
		[52146]=0, -- str/haste perfect
		[52141]=0, -- parry/mastery perfect
		[52149]=0, -- str/crit perfect
		[52139]=0, -- exp/mastery perfect
		[52151]=0, -- agil/dodge perfect
		[52147]="addon.opt.allowPerfectUncommon and 2 or 0", -- int/crit perfect
		[52144]="addon.opt.allowPerfectUncommon and 2 or 0", -- int/haste perfect
		[52150]=0, -- exp/dodge perfect
		[52143]=0, -- str/mastery perfect
		[52115]=0, -- agil/mastery uncommon
		[52117]="addon.opt.allowImperfectUncommon and 2 or 0", -- int/mastery uncommon
		[52109]=0, -- agil/crit uncommon
		[52112]=0, -- agil/haste uncommon
		[52111]=0, -- str/haste uncommon
		[52116]=0, -- parry/mastery uncommon
		[52108]=0, -- str/crit uncommon
		[52118]=0, -- exp/mastery uncommon
		[52106]=0, -- agil/dodge uncommon
		[52110]="addon.opt.allowImperfectUncommon and 2 or 0", -- int/crit uncommon
		[52113]="addon.opt.allowImperfectUncommon and 2 or 0", -- int/haste uncommon
		[52107]=0, -- exp/dodge uncommon
		[52114]=0, -- str/mastery uncommon
		--------------
		-- cogwheel --
		--------------
		[59491]=0, -- parry
		[59480]=2, -- mastery
		[59489]=0, -- expertise
		[59479]=2, -- haste
		[59493]=2, -- hit
		[59478]=2, -- crit
		[59496]=2, -- spirit
		[59477]=0, -- dodge
	},
	enchanting = {
		noclass=0, -- non-listed are undesirable (X)
		----------
		-- back --
		----------
		[4064]=0, -- 70 spen
		[4072]=2, -- 30 int
		[4087]=2, -- 50 crit
		[4090]=0, -- 250 armor
		[4096]=2, -- 50 int
		[4100]=2, -- 65 crit
		[4116]=1, -- tailoring mana restore (darkglow)
		[4115]=2, -- tailoring spell power (lightweave)
		[4118]=0, -- tailoring attack power (swordguard)
		-----------
		-- chest --
		-----------
		[4063]=2, -- 15 stats
		[4070]=1, -- 55 stam
		[4077]=0, -- 40 resil
		[4088]=2, -- 40 spirit
		[4103]=1, -- 75 stam
		[4102]=2, -- 20 stats
		----------
		-- feet --
		----------
		[4062]=2, -- 30 stam and movespeed
		[4069]=2, -- 50 haste
		[4076]=1, -- 35 agi
		[4092]=2, -- 50 hit
		[4094]=2, -- 50 mastery
		[4105]=1, -- 25 agil and movespeed
		[4104]=2, -- 35 mastery and movespeed
		------------------------
		-- ring self-enchants --
		------------------------
		[4079]=0, -- agi
		[4081]=1, -- stam
		[4080]=2, -- int
		[4078]=0, -- str
		-----------
		-- hands --
		-----------
		[4061]=2, -- 50 mastery
		[4068]=2, -- 50 haste
		[4075]=0, -- 35 str
		[4082]=0, -- 50 exp
		[4107]=2, -- 65 mastery
		[4106]=0, -- 50 str
		[3246]=2, -- 28 sp
		[3253]=0, -- 2% threat 10 parry (armsman)
		----------
		-- head --
		----------
		[4208]=0, -- 60 str 35 mastery
		[4206]=0, -- 90 stam 35 dodge
		[4209]=0, -- 60 agil 35 haste
		[4207]=2, -- 60 int 35 crit
		--------------
		-- off-hand --
		--------------
		[4091]=2, -- 100 int
		------------
		-- weapon --
		------------
		[4067]=0, -- nature damage proc (avalanche)
		[4066]=0, -- heal proc [procs off dots] (mending)
		[4074]=0, -- arcane damage + silence proc only vs elementals (elemental slayer)
		[4083]=2, -- 450 haste proc (hurricane)
		[4084]=1, -- 200 spirit oncast proc (heartsong)
		[4099]=0, -- 1000 ap proc (landslide)
		[4097]=2, -- 500 int oncast proc (power torrent)
		[4098]=0, -- 600 dodge 15% movespeed proc (windwalk)
		[3834]=2, -- 63 sp
		[3830]=1, -- 50 sp
		------------
		-- ranged --
		------------
		[4177]=0, -- 88 ranged haste
		[4176]=0, -- 88 ranged hit
		[4175]=0, -- 800 ap ranged proc
		------------
		-- shield --
		------------
		[4085]=0, -- 40 block rating
		[4073]=0, -- 160 armor
		--------------
		-- shoulder --
		--------------
		[4197]=0, -- stam/dodge honored
		[4205]=0, -- agi/mastery honored
		[4201]=0, -- str/crit honored
		[4199]=2, -- int/haste honored
		[4198]=0, -- stam/dodge exalted
		[4204]=0, -- agi/mastery exalted
		[4202]=0, -- str/crit exalted
		[4200]=2, -- int/haste exalted
		[4193]=0, -- 130 agi 25 mastery (inscription self-enchant)
		[4196]=2, -- 130 int 25 haste (inscription self-enchant)
		[4195]=0, -- 195 stam 25 dodge (inscription self-enchant)
		[4194]=0, -- 130 str 25 crit (inscription self-enchant)
		---------------
		-- 2h weapon --
		---------------
		[4227]=0, -- 130 agi
		-----------
		-- wrist --
		-----------
		[4065]=2, -- 50 haste
		[4071]=2, -- 50 crit
		[4086]=0, -- 50 dodge
		[4089]=2, -- 50 hit
		[4093]=2, -- 50 spirit
		[4095]=0, -- 50 exp
		[4101]=2, -- 65 crit
		[4108]=2, -- 65 haste
		[4190]=0, -- 130 agi
		[4192]=2, -- 130 int
		[4189]=0, -- 195 stam
		[4191]=0, -- 130 str
		[2332]=2, -- 30 sp
		[3850]=0, -- 40 stam
		----------
		-- legs --
		----------
		[4127]=0, -- 145 stam 55 agi
		[4126]=0, -- 190 ap 55 crit
		[4112]=1, -- 95 int 80 stam
		[4113]=1, -- 95 int 80 stam tailoring
		[4110]=2, -- 95 int 55 spir
		[4124]=0, -- 85 stam 45 agi
		[4122]=0, -- 110 ap 45 crit
		[4111]=2, -- 55 int 65 stam
		[4109]=2, -- 55 int 45 spir
		-----------
		-- staff --
		-----------
		[3854]=2, -- 81 sp
		[3855]=1, -- 69 sp
	},
	stats = {
		noclass=0, -- non-listed are undesirable (X)
		inherits="Generic",
		ITEM_MOD_CRIT_RATING_SHORT=2, -- crit rating
		ITEM_MOD_MASTERY_RATING_SHORT=2, -- mastery
		ITEM_MOD_STRENGTH_SHORT=0, -- str
		ITEM_MOD_AGILITY_SHORT=0, -- agility
		ITEM_MOD_HASTE_RATING_SHORT=2, -- haste
		ITEM_MOD_SPELL_POWER_SHORT=2, -- spell power
		ITEM_MOD_SPIRIT_SHORT=2, -- spirit
		ITEM_MOD_INTELLECT_SHORT=2, -- intellect
		ITEM_MOD_SPELL_PENETRATION_SHORT=1, -- spell pen
		ITEM_MOD_RESILIENCE_RATING_SHORT=0, -- resil
		ITEM_MOD_HEALTH_REGEN_SHORT=0, -- hp regen
		ITEM_MOD_ATTACK_POWER_SHORT=0, -- ap
		ITEM_MOD_EXPERTISE_RATING_SHORT=0, -- exp
		ITEM_MOD_HIT_RATING_SHORT=2, -- hit
		ITEM_MOD_PARRY_RATING_SHORT=0, -- parry
		ITEM_MOD_DODGE_RATING_SHORT=0, -- dodge
	},
	noenchant={
		inherits="Generic",
	}
}

templates["Healer"] = {
	inherits="debug_approveall",
}

templates["Ranged"]={
	inherits="debug_approveall",
	noenchant={
		Ranged=0, -- hunters need ranged enchants
	},
}

templates["debug_approveall"] = {
	noenchant={
		inherits="Generic",
	},
	stats={
		noclass=2,
	},
	enchanting={
		noclass=2,
	},
	gemming={
		noclass=2,
	},
}